'Beispiel Aquariumsteuerung

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

Licht Alias Portb.6
Config Licht = Output

Luftpumpe Alias Portb.7
Config Luftpumpe = Output

Alarm_led Alias Portb.2
Config Alarm_led = Output

Buzzer Alias Portb.1
Config Buzzer = Output

On Int0 Alarm_reset
Sw1 Alias Pind.2
Config Sw1 = Input
Portd.2 = 1
Config Int0 = Falling
Enable Int0


Ldr Alias Getadc(6)
Poti Alias Getadc(7)

'Timer und der Teiler festlegen 10ms
Config Timer0 = Timer , Prescale = 1024
On Timer0 Timer_irq
Const Timervorgabe = 175
Enable Timer0
Enable Interrupts

Dim Cnt As Byte
Dim Sekunde As Byte
Dim Minute As Byte
Dim Stunde As Byte
Dim Sekunde_last As Byte

Dim Raw As Word
Dim Raw_last As Word
Dim Grad As Single
Dim Grad_str As String * 4
Dim Mittel(40) As Word
Dim Mittel_sum As Word
Dim X As Byte
Dim Licht_flag As Bit
Dim Temp_flag As Bit
Dim A As Byte
Dim S As Byte
Dim Alarm_flag As Bit
Dim Y As Byte

Const Ein = 1
Const Aus = 0

'Zeit Einstellung
Const Licht_ein_std = 8
Const Licht_ein_min = 0

Const Licht_aus_std = 22
Const Licht_aus_min = 0

Const Luft_ein_std = 15
Const Luft_ein_min = 0

Const Luft_aus_std = 20
Const Luft_aus_min = 0

Input "Stunde eingeben: " , Stunde
Input "Minute eingeben: " , Minute

Sekunde = 0
Licht = Aus
Luftpumpe = Aus
Alarm_led = Aus

If Stunde >= Licht_ein_std And Stunde <= Licht_aus_std Then
   Licht = Ein
   Licht_flag = 1
End If

If Stunde >= Luft_ein_std And Stunde <= Luft_aus_std Then Luftpumpe = Ein

Do

        'Licht ein-/ ausschalten
        If Stunde = Licht_ein_std And Minute = Licht_ein_min Then
           Licht = Ein
           Licht_flag = 1
        End If

        If Stunde = Licht_aus_std And Minute = Licht_aus_min Then
           Licht = Aus
           Licht_flag = 0
        End If


        'Luftpumpe ein-/ ausschalten
        If Stunde = Luft_ein_std And Minute = Luft_ein_min Then Luftpumpe = Ein
        If Stunde = Luft_aus_std And Minute = Luft_aus_min Then Luftpumpe = Aus


        'Beleuchtungsberwachung
        If Ldr > Poti And Licht_flag = 1 Then Alarm_flag = 1


        'Temperaturberwachung
        For X = 1 To 40
           Mittel(x) = Getadc(5)
           Waitms 50
        Next

        For X = 1 To 40
           Mittel_sum = Mittel_sum + Mittel(x)
        Next

        Raw = Mittel_sum / 40
        Mittel_sum = 0
        Grad = Raw * 4.68                                   'Ub Messen und hier eintragen!
        Grad = Grad / 1024
        Grad = Grad * 100
        Grad = Grad - 273.15

        If Grad < 25 Or Grad > 28 Then Alarm_flag = 1

        Gosub Show_data

Loop


'Systemtimer aufrufen
Show_data:
  If Sekunde <> Sekunde_last Then
     Print "Uhrzeit = " ; Stunde ; ":" ; Minute ; ":" ; Sekunde
     Grad_str = Fusing(grad , "#.#")
     Print "Temp: " ; Grad_str ; " C"
     Print "Luftpumpe = " ; Luftpumpe
     Print "Licht = " ; Licht
     Print "Alarm = " ; Alarm_flag
     Print
     Sekunde_last = Sekunde
  End If
Return


Alarm:

  Incr Y
  If Y = 50 Then
     Y = 0
     Toggle Alarm_led
  End If

Return

Alarm_reset:
   Alarm_flag = 0
   Alarm_led = 0
Return

Timer_irq:
Timer0 = Timervorgabe

   Incr Cnt

   'Sekunde hochzhlen
   If Cnt => 100 Then
      Incr Sekunde
      'Toggle Portb.6
      Cnt = 0
   End If

   'Minuten hochzhlen
   If Sekunde > 59 Then
      Incr Minute
      Sekunde = 0
   End If


   'Stunde hochzhlen
   If Minute > 59 Then
      Incr Stunde
      Minute = 0
   End If

   If Stunde > 23 Then Stunde = 0

   If Alarm_flag = 1 Then Gosub Alarm

Return
End