'Bascom Temperatur Logger

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200
$eeprom

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'Timer und der Teiler festlegen 10ms
Config Timer0 = Timer , Prescale = 1024
On Timer0 Timer_irq
Const Timervorgabe = 175
Enable Timer0
Enable Interrupts

Config Pind.2 = Input
Portd.2 = 1

Config Portb.6 = Output
Config Portb.7 = Output

Const Prompt = ":\ "

Dim B As Byte
Dim X As Word
Dim Var1 As Byte
Dim Var2 As Word
Dim Addr As Word
Dim Eingabe As String * 1

Dim Raw As Word
Dim Grad As Single
Dim Grad_str As String * 4
Dim Mittel(10) As Word
Dim Mittel_sum As Word
Dim Cnt As Byte
Dim Sekunde As Byte
Dim Minute As Byte
Dim Stunde As Byte
Dim Sekunde_last As Byte
Dim Minute_last As Byte
'Dim Stunde_last As Byte

Main:
Addr = 0
Readeeprom Stunde , 501
Readeeprom Minute , 502
If Pind.2 = 0 Then
   Waitms 50
   If Pind.2 = 0 Then Gosub Write_data
End If


$data
Print "(W) WRITE DATA"
Print "(R) READ DATA"
Print "(C) CLEAR"
Print "(S) SET RTC"
Print "(I) INFO"
Print "(X) RESET"

Do
Input Prompt , Eingabe
Select Case Eingabe

        Case "W"
        Gosub Write_data

        Case "R"
        Gosub Read_data

        Case "C"
        Gosub Clr_eeprom

        Case "S"
        Gosub Set_rtc

        Case "I"
        Print Stunde ; ":" ; Minute
        Gosub Read_raw
        Var2 = Raw
        Gosub Calc_temp

        Case "X"
        Goto Main

        Case Else
        Print "ERROR"
End Select
Loop

Write_data:
   Addr = 0
   Minute_last = 99
   'Stunde_last = 99

   Do
     If Sekunde <> Sekunde_last Then Toggle Portb.7

     'If Stunde <> Stunde_last Then
     If Minute <> Minute_last Then

        Gosub Read_raw

        Addr = Addr + 1
        Writeeeprom Stunde , Addr
        Addr = Addr + 1
        Writeeeprom Minute , Addr
        Addr = Addr + 1
        Writeeeprom Sekunde , Addr
        Addr = Addr + 1
        Writeeeprom Raw , Addr
        Addr = Addr + 1

     End If

     Sekunde_last = Sekunde
     Minute_last = Minute
     'Stunde_last = Stunde

     If Addr > 499 Then Exit Do

   Loop

   Do
     Toggle Portb.7
     Waitms 250
   Loop
Return

Read_raw:
    For X = 1 To 10
        Mittel(x) = Getadc(6)
        Waitms 100
        Toggle Portb.7
    Next

    For X = 1 To 10
        Mittel_sum = Mittel_sum + Mittel(x)
    Next

    Raw = Mittel_sum / 10
    Mittel_sum = 0
Return

Read_data:
   Addr = 0
   Do
      Addr = Addr + 1
      Readeeprom Var1 , Addr
      Print Var1 ; ":";
      Addr = Addr + 1
      Readeeprom Var1 , Addr
      Print Var1 ; ":";
      Addr = Addr + 1
      Readeeprom Var1 , Addr
      Print Var1 ; " ";
      Addr = Addr + 1
      Readeeprom Var2 , Addr

      Gosub Calc_temp

      Addr = Addr + 1
      If Addr > 499 Then Exit Do
   Loop
Return


Calc_temp:
   Grad = Var2 * 4.295                                      'AVCC Messen und hier eintragen!
   Grad = Grad / 1024
   Grad = Grad * 100
   Grad = Grad - 273.15
   Grad_str = Fusing(grad , "#.#")
   Print Grad_str
Return

Clr_eeprom:
   Input "CLR (Y/N)? " , Eingabe
   If Eingabe = "Y" Then
      Portb.7 = 1
      For X = 1 To 512
          B = &HFF
          Writeeeprom B , X
      Next
      Portb.7 = 0
      Goto Main
   Else
      Return
   End If
Return

Set_rtc:
   Input "H:" , Stunde
   Input "M:" , Minute
   Writeeeprom Stunde , 501
   Writeeeprom Minute , 502
Return

Timer_irq:
   Timer0 = Timervorgabe

   Incr Cnt

    If Cnt = 50 Then
       Portb.6 = 0
    End If

    If Cnt = 100 Then
       Portb.6 = 1
       Sekunde = Sekunde + 1
       If Sekunde = 60 Then
          Sekunde = 0
          Minute = Minute + 1
          If Minute = 60 Then
             Minute = 0
             Stunde = Stunde + 1
             If Stunde = 24 Then
                Stunde = 0
             End If
          End If
       End If
       Cnt = 0
    End If

Return
End
